﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using System.IO;
using System.Windows.Forms;

namespace Xenon.ListGraphic
{

    public abstract class Actions_File
    {

        public static string Path_ReportDirectory
        {
            get
            {
                StringBuilder sb = new StringBuilder();

                sb.Append(Application.StartupPath);
                sb.Append(Path.DirectorySeparatorChar);
                sb.Append("レポート");

                return sb.ToString();
            }
        }

        public static string Path_ReportLoadgraphicCsv
        {
            get
            {
                StringBuilder sb = new StringBuilder();

                sb.Append(Actions_File.Path_ReportDirectory);
                sb.Append(Path.DirectorySeparatorChar);
                sb.Append("report_loadGraphic.csv");

                return sb.ToString();
            }
        }

        public static string Path_ReportLocalCsv
        {
            get
            {
                StringBuilder sb = new StringBuilder();

                sb.Append(Actions_File.Path_ReportDirectory);
                sb.Append(Path.DirectorySeparatorChar);
                sb.Append("report_local.csv");

                return sb.ToString();
            }
        }

        public static string Path_ReportFunctionCsv
        {
            get
            {
                StringBuilder sb = new StringBuilder();

                sb.Append(Actions_File.Path_ReportDirectory);
                sb.Append(Path.DirectorySeparatorChar);
                sb.Append("report_function.csv");

                return sb.ToString();
            }
        }

        public static string Path_ReportFunctioncallCsv
        {
            get
            {
                StringBuilder sb = new StringBuilder();

                sb.Append(Actions_File.Path_ReportDirectory);
                sb.Append(Path.DirectorySeparatorChar);
                sb.Append("report_functioncall.csv");

                return sb.ToString();
            }
        }

        public static string Path_ReportGraphicHtml
        {
            get
            {
                StringBuilder sb = new StringBuilder();

                sb.Append(Actions_File.Path_ReportDirectory);
                sb.Append(Path.DirectorySeparatorChar);
                sb.Append("report_graphic.html");

                return sb.ToString();
            }
        }

        public static void Write( string path, string text )
        {
            File.WriteAllText(path, text, Encoding.GetEncoding("Shift-JIS"));
        }

        /// <summary>
        /// 書き込めるかどうかを調べます。
        /// </summary>
        public static bool CanWrite(string path, out string errorMessage)
        {
            bool successful = true;
            errorMessage = "";

            StreamWriter w = null;
            try
            {
                w = new StreamWriter(path);
            }
            catch (Exception ex)
            {
                StringBuilder sb = new StringBuilder();
                sb.AppendLine("ファイルを閉じて下さい。");
                sb.AppendLine(path);
                sb.AppendLine();
                sb.AppendLine(ex.ToString());
                errorMessage = sb.ToString();

                MessageBox.Show(errorMessage, "警告", MessageBoxButtons.OK, MessageBoxIcon.Warning);
                successful = false;
            }
            finally
            {
                if (null != w)
                {
                    w.Close();
                }
            }

            return successful;
        }
    }
}
