﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Xenon.ListGraphic
{
    public abstract class Actions_Text
    {

        /// <summary>
        /// 両端をダブルクォーテーションで挟まれている文字列なら、両端のダブルクォーテーションを外します。
        /// </summary>
        /// <param name="src"></param>
        /// <returns></returns>
        public static string TrimDoubleQuotation(string src)
        {
            string value = src.Trim();
            if (2 <= value.Length && value.StartsWith(@"""") && value.EndsWith(@"""") && value.IndexOf('"', 1, value.Length - 2) < 0)
            {
                // リテラル文字列でした。＜サンプル＞ "aaaa"
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                value = value.Substring(1, value.Length - 2);
            }
            else
            {
                // 変数名かもしれません。
                //>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

                // ＜サンプル＞ chrSymbol .. "_" .. graName
            }

            return value;
        }

    }
}
