﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Diagnostics;
using System.IO;

namespace Xenon.ListGraphic
{
    public partial class UcMain : UserControl
    {
        public UcMain()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.dlgFolderBrowser.SelectedPath = this.txtFolder1.Text;

            switch (this.dlgFolderBrowser.ShowDialog(this))
            {
                case DialogResult.OK:
                    this.txtFolder1.Text = this.dlgFolderBrowser.SelectedPath;
                    break;
                default:
                    break;
            }

        }


        /// <summary>
        /// [実行]ボタン
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnJikkou_Click(object sender, EventArgs e)
        {
            this.txtStatus.Text = "";
            
            Form_Jikkou dlg = new Form_Jikkou();
            dlg.DirectoryPath = this.txtFolder1.Text;
            
            switch (dlg.ShowDialog(this))
            {
                case DialogResult.OK:

                    //------------------------------------------------------------
                    // 書出：　グラフィックCSV
                    //------------------------------------------------------------
                    Actions_File.Write(Actions_File.Path_ReportLoadgraphicCsv, dlg.ReportLoadgraphicCsv());

                    //------------------------------------------------------------
                    // 書出：　ローカルCSV
                    //------------------------------------------------------------
                    Actions_File.Write(Actions_File.Path_ReportLocalCsv, dlg.ReportLocalCsv());

                    //------------------------------------------------------------
                    // 書出：　ファンクションCSV
                    //------------------------------------------------------------
                    Actions_File.Write(Actions_File.Path_ReportFunctionCsv, dlg.ReportFunctionCsv());

                    //------------------------------------------------------------
                    // 書出：　関数呼出しCSV
                    //------------------------------------------------------------
                    Actions_File.Write(Actions_File.Path_ReportFunctioncallCsv, dlg.ReportFunctioncallCsv());

                    //------------------------------------------------------------
                    // 書出：　グラフィックHTML
                    //------------------------------------------------------------
                    Actions_File.Write(Actions_File.Path_ReportGraphicHtml, dlg.ReportLoadgraphicHtml( dlg.Report_Local));


                    // 日時
                    string dateTime;
                    {
                        StringBuilder sb2 = new StringBuilder();
                        DateTime dt = DateTime.Now;
                        sb2.Append("(");
                        sb2.Append(dt.Year);
                        sb2.Append("年");
                        sb2.Append(dt.Month);
                        sb2.Append("月");
                        sb2.Append(dt.Day);
                        sb2.Append("日");
                        sb2.Append(dt.Hour);
                        sb2.Append("時");
                        sb2.Append(dt.Minute);
                        sb2.Append("分");
                        sb2.Append(dt.Second);
                        sb2.Append("秒");
                        sb2.Append(")");
                        dateTime = sb2.ToString();
                    }

                    StringBuilder sb = new StringBuilder();

                    sb.Append(dateTime);
                    sb.Append("　書出：　");
                    sb.Append(Actions_File.Path_ReportGraphicHtml);
                    sb.AppendLine();

                    sb.Append(dateTime);
                    sb.Append("　書出：　");
                    sb.Append(Actions_File.Path_ReportLoadgraphicCsv);
                    sb.AppendLine();

                    sb.Append(dateTime);
                    sb.Append("　書出：　");
                    sb.Append(Actions_File.Path_ReportLocalCsv);
                    sb.AppendLine();

                    this.txtStatus.Text = sb.ToString();

                    //------------------------------------------------------------
                    // ブラウザーの起動
                    //------------------------------------------------------------
                    Process.Start("file:///" + Actions_File.Path_ReportGraphicHtml);

                    break;

                case DialogResult.Cancel:
                    if ("" != dlg.ErrorMessage)
                    {
                        this.txtStatus.Text = dlg.ErrorMessage;
                    }
                    break;

                default:
                    break;
            }

        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == System.Windows.Forms.Keys.A & e.Control == true)
            {
                ((TextBox)sender).SelectAll();
            } 
        }

        private void UcMain_Load(object sender, EventArgs e)
        {
            //------------------------------------------------------------
            // 初期値
            //------------------------------------------------------------
            this.txtFolder1.Text = Application.StartupPath;
            
        }
    }
}
